# -*- coding: utf-8 -*-
"""
/***************************************************************************
 ppqgisDialog
                                 A QGIS plugin
 Plugin to work with pandapower networks
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2022-09-23
        git sha              : $Format:%H$
        copyright            : (C) 2022 by Fraunhofer IEE
        email                : mike.vogt@iee.fraunhofer.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.PyQt import uic, QtWidgets

# This loads your .ui file so that PyQt can populate your plugin with the elements from Qt Designer
FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'pandapower_import_dialog_base.ui'))


class ppImportDialog(QtWidgets.QDialog, FORM_CLASS):
    def __init__(self, parent=None):
        """Constructor."""
        super(ppImportDialog, self).__init__(parent)
        # Set up the user interface from Designer through FORM_CLASS.
        # After self.setupUi() you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://qt-project.org/doc/qt-4.8/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

    # These functions are for converting the import window for different types of networks
    def convert_to_pipes(self):
        self.setWindowTitle(self.tr("Import pandapipes network"))
        self.layerNameEdit.setText("pandapipesnet")
        self.runpp.setText(self.tr("Run pandapipes"))
        self.gradRender.setText(self.tr("color pipes by pressure"))
        self.folderSelect.setDialogTitle(self.tr("Import pandapipes network - Select save folder:"))

    def convert_to_power(self):
        self.setWindowTitle(self.tr("Import pandapower network"))
        self.layerNameEdit.setText("pandapowernet")
        self.runpp.setText(self.tr("Run pandapower"))
        self.gradRender.setText(self.tr("color lines by load"))
        self.folderSelect.setDialogTitle(self.tr("Import pandapower network - Select save folder:"))
